; GDIptest.inc
; part of GDIptest.asm
;dougiem0305
;dougiem@dougiem.fsnet.co.uk

     ; masm includes
       include \masm32\include\windows.inc

       include \masm32\include\user32.inc
       include \masm32\include\kernel32.inc
       include \MASM32\INCLUDE\gdi32.inc
       include \masm32\include\comctl32.inc
       include \masm32\include\comdlg32.inc
       include \masm32\include\masm32.inc


       includelib \masm32\lib\user32.lib
       includelib \masm32\lib\kernel32.lib
       includelib \MASM32\LIB\gdi32.lib
       includelib \masm32\lib\comctl32.lib
       includelib \masm32\lib\comdlg32.lib
       includelib \masm32\lib\masm32.lib


;    MACROS   -----------------------------

      m2m macro arg1,arg2
        push arg2
        pop arg1
      endm

;    EXAMPLE - jmpif eax,NE,ebx,location
;    same as -     cmp eax,ebx
;                  jne location
     jmpif macro val1,val2,val3,val4
       cmp val1,val3
       j&val2& val4
     endm

;    EXAMPLE - jmpmif mem1,NE,mem2,NotEqual
     jmpmif macro val1,val2,val3,val4
       push eax
       mov eax,val1
       cmp eax,val3
       pop eax
       j&val2& val4
     endm


;    LOCAL FILES   ----------------------------------------------------
       include     gdipFiles\gdiplus_V0a.inc               ; prototypes
       includelib  gdipFiles\gdiplus.lib
       include     gdipFiles\gdiplus_structures_ver1.inc

       include     gdipFiles\gdipfunctions.asm


; ----------------------------------------------------------------------

         WinMain             PROTO :DWORD,:DWORD,:DWORD,:DWORD
         WndProc             PROTO :DWORD,:DWORD,:DWORD,:DWORD
         TopXY               PROTO :DWORD,:DWORD
         LoadButtons         PROTO :dword

; ------------------------------------------------------------------------
.data?

POSIT struct
     x  dword ?
     y  dword ?
     w  dword ?
     h  dword ?
POSIT ends

.data



     utFileName         db MAX_PATH*2 DUP (0)

     but1               db "Load image",0
     but2               db "Save image",0
     but3               db "FILL",0
     but4               db "FIT",0
     but5               db "FULL",0
     but6               db "T E S T A",0
     but7               db "T E S T B",0

     ButtClass          db "button",0
     statclass          db "static",0
     szClassName        db "GDIPlusImage",0
     szDisplayName      db "GDI+ image Test routines",0
     szDisplayName1     db "GDI+ Test routines                    Load image",0
     szDisplayName2     db "GDI+ Test routines                    Save image",0
     szError1           db "Not a supported format",0
     szError2           db "Cannot overwrite an open file  -  Change the file name",0
     FontName1          db "MS Sans Serif",0
     CommandLine        dd 0
     hWnd               dd 0
     hWtxt              dd 0
     hInstance          dd 0

     lf                 LOGFONT < >
     hFont1             dd 0
     ; init struct GDI+
     GdiPlusSI GdiplusStartupInput{1,NULL,FALSE,FALSE}

     intW               dd 0      ; holds original image size
     intH               dd 0

     winW               dd 468    ; image display window size
     winH               dd 352

     lastW              dd 0      ; test with current
     lastH              dd 0      ; for clear

     hGDIplus           dd 0      ; main handle
     GpImage            dd 0      
     GpGraphics         dd 0

     hasImage           dd 0      ; flag
     BkGrnd             dd 0      ; background colour

     fType              db 20 DUP (0)
     fTypeB             db "image/%hs",0

     IClsid             GUID <>

     Quality            dd 50     ; value for jpeg quality
     jpegFlag           dd 0      ; flag

     hWimage            dd 0
     hDC                dd 0

     Percent            dd 0
     fptPcent           REAL4 0.0

     eps                EncoderParameters <>
     dst                POSIT <>
     src                POSIT <>

                        ; supported read formats
Imagefilter   db "Supported Image Files",0,"*.bmp;*.gif;*.jpg;*.jpe;*.jpeg;*.png;*.tiff;*.ico;*.wmf;*.emf;*.exif",0,
                   "Bitmap (.BMP)",0,"*.bmp",0,
                   "Jpeg (.JPG .JPE .JPEG)",0,"*.jpg;*.jpe;*.jpeg",0,"Gif (.GIF)",0,"*.gif",0,
                   "Png (.PNG)",0,"*.png",0,"Tiff (.TIFF)",0,"*.tiff",0,
                   "Ico (.ICO)",0,"*.ico",0,"Wmf (.WMF)",0,"*.wmf",0,"Emf (.EMF)",0,"*.emf",0,
                   "Exif (.EXIF)",0,"*.exif",0,0

                        ; supported write formats
Imagefilter2  db "Supported Image Files",0,"*.bmp;*.gif;*.jpg;*.jpe;*.jpeg;*.png;*.tiff",0,"Bitmap (.BMP)",0,"*.bmp",0,
                   "Jpeg (.JPG .JPE .JPEG)",0,"*.jpg;*.jpe;*.jpeg",0,"Gif (.GIF)",0,"*.gif",0,
                   "Png (.PNG)",0,"*.png",0,"Tiff (.TIFF)",0,"*.tiff",0,0


pctxt         db 100 DUP (0)
pctxtB        db " %hs     Image: %lu x %lu      Showing: %lu%%",0


;